import { Server, WebSocket, CloseOptions } from "mock-socket";
import Queue from "./queue";
interface WSOptions {
    jsonProtocol?: boolean;
}
export declare type DeserializedMessage<TMessage = object> = string | TMessage;
interface MockWebSocket extends Omit<WebSocket, "close"> {
    close(options?: CloseOptions): void;
}
export default class WS {
    server: Server;
    connected: Promise<WebSocket>;
    closed: Promise<{}>;
    serializer: (deserializedMessage: DeserializedMessage) => string;
    deserializer: (message: string) => DeserializedMessage;
    static instances: Array<WS>;
    messages: Array<DeserializedMessage>;
    messagesToConsume: Queue<unknown>;
    static clean(): void;
    constructor(url: string, { jsonProtocol }?: WSOptions);
    on(eventName: "connection" | "message" | "close", callback: (socket: MockWebSocket) => void): void;
    get nextMessage(): Promise<unknown>;
    send(message: DeserializedMessage): void;
    close(): void;
    error(): void;
}
export {};
